#ifndef SELECTOR_HPP
#define SELECTOR_HPP

#include "sceneObject.hpp"

#include <string>
#include <vector>

//! TODO
class Selector : public SceneObject {
public:
	Selector(const std::string& name, Scene* scene);
	~Selector();

	virtual void reset();
	virtual void draw() const;
	virtual void update(double deltaT);
	virtual void pickObject(const glm::ivec2& mouse);

	int getBufferWidth() const { return width; }
	int getBufferHeight() const { return height; }
	size_t getLastSelected() const { return lastSelected; }
	size_t getLastDistance() const { return lastDistance; }

protected:
	int width;
	int height;
	GLuint idBuffer;
	GLuint idTexture;

	size_t lastDistance;
	size_t lastSelected;

};

#endif //SELECTOR_HPP
